function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import React, { useMemo } from 'react';
import classNames from 'classnames';
import { CardPro } from '@pisell/materials';
import { PREFIX } from "../../status";
import Action from "../Action";
import TooltipTags from "../TooltipTags";
import CardMask from "../CardMask";
import "./index.less";
var CardWrapper = function CardWrapper(props) {
  var children = props.children,
    className = props.className,
    style = props.style,
    skuCardConfig = props.skuCardConfig,
    skuActionConfig = props.skuActionConfig,
    skuStatusOverlayConfig = props.skuStatusOverlayConfig,
    dataSource = props.dataSource,
    onCardClick = props.onCardClick,
    isSelected = props.isSelected;
  var _ref = skuCardConfig || {},
    paddingX = _ref.paddingX,
    paddingY = _ref.paddingY,
    background = _ref.background,
    marginY = _ref.marginY,
    marginX = _ref.marginX,
    radius = _ref.radius,
    borderWidth = _ref.borderWidth,
    borderColor = _ref.borderColor,
    isBorderVisible = _ref.isBorderVisible,
    layoutDirection = _ref.layoutDirection;
  var _ref2 = skuActionConfig || {},
    method = _ref2.method;
  var finalStyle = useMemo(function () {
    return _objectSpread(_objectSpread({}, style), {}, {
      backgroundColor: background,
      padding: "".concat(paddingY, "px ").concat(paddingX, "px"),
      margin: "".concat(marginY, "px ").concat(marginX, "px"),
      borderRadius: radius,
      border: isBorderVisible ? "".concat(borderWidth, "px solid ").concat(borderColor) : 'none'
    });
  }, [style, paddingX, paddingY, borderWidth, borderColor, isBorderVisible, radius, background, marginX, marginY]);
  return /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(PREFIX, "__card-wrapper"), (skuStatusOverlayConfig === null || skuStatusOverlayConfig === void 0 ? void 0 : skuStatusOverlayConfig.isOpen) && "".concat(PREFIX, "__card-wrapper-overlay"), className),
    onClick: function onClick(e) {
      e.stopPropagation();
      onCardClick === null || onCardClick === void 0 || onCardClick(dataSource);
    }
  }, /*#__PURE__*/React.createElement(CardPro, {
    isMedia: false,
    isShowHead: false,
    isShowFooter: false,
    className: classNames("".concat(PREFIX, "__card-wrapper-card"), isSelected && "".concat(PREFIX, "__card-wrapper-selected")),
    style: finalStyle
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(PREFIX, "__card-wrapper-children")
  }, children), /*#__PURE__*/React.createElement(CardMask, {
    props: skuStatusOverlayConfig || {}
  }), layoutDirection === 'column' && method !== 'button' ? /*#__PURE__*/React.createElement("div", {
    className: "".concat(PREFIX, "__card-wrapper-action"),
    style: {
      bottom: paddingY,
      right: paddingX
    }
  }, /*#__PURE__*/React.createElement(Action, {
    props: props
  })) : null, /*#__PURE__*/React.createElement(TooltipTags, {
    props: props
  })));
};
export default CardWrapper;